package io.renren.modules.sys.controller;

import io.renren.common.annotation.LogOperation;
import io.renren.common.constant.Constant;
import io.renren.common.exception.RenException;
import io.renren.common.page.PageData;
import io.renren.common.utils.ExcelUtils;
import io.renren.common.utils.Result;
import io.renren.common.validator.AssertUtils;
import io.renren.common.validator.ValidatorUtils;
import io.renren.common.validator.group.AddGroup;
import io.renren.common.validator.group.DefaultGroup;
import io.renren.common.validator.group.UpdateGroup;
import io.renren.modules.security.user.SecurityUser;
import io.renren.modules.security.user.UserDetail;
import io.renren.modules.sys.dto.ScopeCityCompanyDTO;
import io.renren.modules.sys.dto.ScopeCityDTO;
import io.renren.modules.sys.excel.ScopeCityCompanyExcel;
import io.renren.modules.sys.service.ScopeCityCompanyService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.CollectionUtils;
import org.springframework.web.bind.annotation.*;
import springfox.documentation.annotations.ApiIgnore;

import javax.servlet.http.HttpServletResponse;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * 落地城市公司明细表
 *
 * @author Mark sunlightcs@gmail.com
 * @since 1.0.0 2022-05-28
 */
@RestController
@RequestMapping("sys/scopecitycompany")
@Api(tags="落地城市公司明细表")
public class ScopeCityCompanyController {
    @Autowired
    private ScopeCityCompanyService scopeCityCompanyService;

    @GetMapping("page")
    @ApiOperation("分页")
    @ApiImplicitParams({
        @ApiImplicitParam(name = Constant.PAGE, value = "当前页码，从1开始", paramType = "query", required = true, dataType="int") ,
        @ApiImplicitParam(name = Constant.LIMIT, value = "每页显示记录数", paramType = "query",required = true, dataType="int") ,
        @ApiImplicitParam(name = Constant.ORDER_FIELD, value = "排序字段", paramType = "query", dataType="String") ,
        @ApiImplicitParam(name = Constant.ORDER, value = "排序方式，可选值(asc、desc)", paramType = "query", dataType="String")
    })
    @RequiresPermissions("sys:scopecity:page")
    public Result<PageData<ScopeCityCompanyDTO>> page(@ApiIgnore @RequestParam Map<String, Object> params){
        PageData<ScopeCityCompanyDTO> page = scopeCityCompanyService.page(params);

        return new Result<PageData<ScopeCityCompanyDTO>>().ok(page);
    }

    @GetMapping("{id}")
    @ApiOperation("信息")
    @RequiresPermissions("sys:scopecity:info")
    public Result<ScopeCityCompanyDTO> get(@PathVariable("id") Long id){
        ScopeCityCompanyDTO data = scopeCityCompanyService.get(id);

        return new Result<ScopeCityCompanyDTO>().ok(data);
    }

    @PostMapping
    @ApiOperation("保存")
    @LogOperation("保存")
    @RequiresPermissions("sys:scopecity:save")
    public Result save(@RequestBody ScopeCityCompanyDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, AddGroup.class, DefaultGroup.class);

        //落地城市主表id+公司 唯一性校验
        Map<String,Object> params = new HashMap<>();
        params.put("scopeCityId",dto.getScopeCityId()+"");
        params.put("companyId",dto.getCompanyId()+"");
        List<ScopeCityCompanyDTO> repeatList = scopeCityCompanyService.list(params);
        if (!CollectionUtils.isEmpty(repeatList)){
            throw new RenException("记录已存在");
        }
        UserDetail userDetail = SecurityUser.getUser();
        dto.setCreateBy(userDetail.getId());
        dto.setCreateTime(new Date());
//        dto.setUpdateBy(userDetail.getId());
//        dto.setUpdateTime(new Date());
        scopeCityCompanyService.save(dto);

        return new Result();
    }

    @PutMapping
    @ApiOperation("修改")
    @LogOperation("修改")
    @RequiresPermissions("sys:scopecity:update")
    public Result update(@RequestBody ScopeCityCompanyDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, UpdateGroup.class, DefaultGroup.class);

        //落地城市主表id+公司 唯一性校验
        Map<String,Object> params = new HashMap<>();
        params.put("scopeCityId",dto.getScopeCityId()+"");
        params.put("companyId",dto.getCompanyId()+"");
        List<ScopeCityCompanyDTO> repeatList = scopeCityCompanyService.list(params);
        if (!CollectionUtils.isEmpty(repeatList)){
            for (ScopeCityCompanyDTO scopeCityCompanyDTO:repeatList){
                if (scopeCityCompanyDTO.getId().longValue()!=dto.getId().longValue()){
                    throw new RenException("记录已存在");
                }
            }
        }
        UserDetail userDetail = SecurityUser.getUser();
        dto.setUpdateBy(userDetail.getId());
        dto.setUpdateTime(new Date());
        scopeCityCompanyService.update(dto);

        return new Result();
    }

    @DeleteMapping
    @ApiOperation("删除")
    @LogOperation("删除")
    @RequiresPermissions("sys:scopecity:delete")
    public Result delete(@RequestBody Long[] ids){
        //效验数据
        AssertUtils.isArrayEmpty(ids, "id");
        UserDetail userDetail = SecurityUser.getUser();
        for (Long id:ids){
            ScopeCityCompanyDTO dto = scopeCityCompanyService.get(id);
            dto.setDeleteTime(new Date());
            dto.setStatus(0);
            dto.setUpdateBy(userDetail.getId());
            scopeCityCompanyService.update(dto);
        }

        return new Result();
    }

    @GetMapping("export")
    @ApiOperation("导出")
    @LogOperation("导出")
    @RequiresPermissions("sys:scopecity:export")
    public void export(@ApiIgnore @RequestParam Map<String, Object> params, HttpServletResponse response) throws Exception {
        List<ScopeCityCompanyDTO> list = scopeCityCompanyService.list(params);

        ExcelUtils.exportExcelToTarget(response, null, list, ScopeCityCompanyExcel.class);
    }

}